<?php

namespace Drupal\prometheusio_exporter\Prometheus;

use Prometheus\CollectorRegistry as PrometheusCollectorRegistryBase;
use Prometheus\Storage\Adapter;

/**
 * CollectorRegistry for plugins.
 *
 * Same as collector registry from lib but has also the capability to
 * wipe storage.
 */
class CollectorRegistryForPlugins extends PrometheusCollectorRegistryBase implements CanWipeStorageInterface {

  /**
   * The storage adapter for prometheus metrics.
   *
   * @var \Prometheus\Storage\Adapter
   */
  protected $storageAdapter;

  /**
   * {@inheritdoc}
   */
  public function __construct(Adapter $storageAdapter, bool $registerDefaultMetrics = TRUE) {
    parent::__construct($storageAdapter, $registerDefaultMetrics);
    $this->storageAdapter = $storageAdapter;
  }

  /**
   * {@inheritdoc}
   */
  public function wipeStorage() {
    $this->storageAdapter->wipeStorage();
  }

}
